package io.xjar.filter;

import java.util.regex.Pattern;
import io.xjar.XEntryFilter;

public abstract class XRegexEntryFilter<E> implements XEntryFilter<E>
{
    protected final Pattern pattern;
    
    protected XRegexEntryFilter(final String regex) {
        this(Pattern.compile(regex));
    }
    
    protected XRegexEntryFilter(final Pattern pattern) {
        this.pattern = pattern;
    }
    
    public boolean filtrate(final E entry) {
        final String text = this.toText(entry);
        return this.pattern.matcher(text).matches();
    }
    
    protected abstract String toText(final E p0);
}
